/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "chuck.y"


/*----------------------------------------------------------------------------
    ChucK Concurrent, On-the-fly Audio Programming Language
      Compiler and Virtual Machine

    Copyright (c) 2004 Ge Wang and Perry R. Cook.  All rights reserved.
      http://chuck.cs.princeton.edu/
      http://soundlab.cs.princeton.edu/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
    U.S.A.
-----------------------------------------------------------------------------*/

//-----------------------------------------------------------------------------
// file: chuck.tab.c
// desc: chuck parser
//
// author: Ge Wang (gewang@cs.princeton.edu) - generated by yacc
//         Perry R. Cook (prc@cs.princeton.edu)
//
// based in part on the ansi C grammar by Jeff Lee, maintained by Jutta Degener
//
// date: Summer 2002
//-----------------------------------------------------------------------------
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#ifndef __PLATFORM_WIN32__
#include <unistd.h>
#else
#define YY_NO_UNISTD_H 1
#include <io.h>
#endif
#include "chuck_utils.h"
#include "chuck_errmsg.h"
#include "chuck_absyn.h"

// function
int yylex( void );

void yyerror( char * s )
{
    EM_error( EM_tokPos, "%s", s );
}

a_Program g_program = NULL;


#line 133 "chuck.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "chuck.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ID = 3,                         /* ID  */
  YYSYMBOL_STRING_LIT = 4,                 /* STRING_LIT  */
  YYSYMBOL_CHAR_LIT = 5,                   /* CHAR_LIT  */
  YYSYMBOL_NUM = 6,                        /* NUM  */
  YYSYMBOL_FLOAT = 7,                      /* FLOAT  */
  YYSYMBOL_POUND = 8,                      /* POUND  */
  YYSYMBOL_COMMA = 9,                      /* COMMA  */
  YYSYMBOL_COLON = 10,                     /* COLON  */
  YYSYMBOL_SEMICOLON = 11,                 /* SEMICOLON  */
  YYSYMBOL_LPAREN = 12,                    /* LPAREN  */
  YYSYMBOL_RPAREN = 13,                    /* RPAREN  */
  YYSYMBOL_LBRACK = 14,                    /* LBRACK  */
  YYSYMBOL_RBRACK = 15,                    /* RBRACK  */
  YYSYMBOL_LBRACE = 16,                    /* LBRACE  */
  YYSYMBOL_RBRACE = 17,                    /* RBRACE  */
  YYSYMBOL_DOT = 18,                       /* DOT  */
  YYSYMBOL_PLUS = 19,                      /* PLUS  */
  YYSYMBOL_MINUS = 20,                     /* MINUS  */
  YYSYMBOL_TIMES = 21,                     /* TIMES  */
  YYSYMBOL_DIVIDE = 22,                    /* DIVIDE  */
  YYSYMBOL_PERCENT = 23,                   /* PERCENT  */
  YYSYMBOL_EQ = 24,                        /* EQ  */
  YYSYMBOL_NEQ = 25,                       /* NEQ  */
  YYSYMBOL_LT = 26,                        /* LT  */
  YYSYMBOL_LE = 27,                        /* LE  */
  YYSYMBOL_GT = 28,                        /* GT  */
  YYSYMBOL_GE = 29,                        /* GE  */
  YYSYMBOL_AND = 30,                       /* AND  */
  YYSYMBOL_OR = 31,                        /* OR  */
  YYSYMBOL_ASSIGN = 32,                    /* ASSIGN  */
  YYSYMBOL_IF = 33,                        /* IF  */
  YYSYMBOL_THEN = 34,                      /* THEN  */
  YYSYMBOL_ELSE = 35,                      /* ELSE  */
  YYSYMBOL_WHILE = 36,                     /* WHILE  */
  YYSYMBOL_FOR = 37,                       /* FOR  */
  YYSYMBOL_DO = 38,                        /* DO  */
  YYSYMBOL_LOOP = 39,                      /* LOOP  */
  YYSYMBOL_BREAK = 40,                     /* BREAK  */
  YYSYMBOL_CONTINUE = 41,                  /* CONTINUE  */
  YYSYMBOL_NULL_TOK = 42,                  /* NULL_TOK  */
  YYSYMBOL_FUNCTION = 43,                  /* FUNCTION  */
  YYSYMBOL_RETURN = 44,                    /* RETURN  */
  YYSYMBOL_QUESTION = 45,                  /* QUESTION  */
  YYSYMBOL_EXCLAMATION = 46,               /* EXCLAMATION  */
  YYSYMBOL_S_OR = 47,                      /* S_OR  */
  YYSYMBOL_S_AND = 48,                     /* S_AND  */
  YYSYMBOL_S_XOR = 49,                     /* S_XOR  */
  YYSYMBOL_PLUSPLUS = 50,                  /* PLUSPLUS  */
  YYSYMBOL_MINUSMINUS = 51,                /* MINUSMINUS  */
  YYSYMBOL_DOLLAR = 52,                    /* DOLLAR  */
  YYSYMBOL_POUNDPAREN = 53,                /* POUNDPAREN  */
  YYSYMBOL_PERCENTPAREN = 54,              /* PERCENTPAREN  */
  YYSYMBOL_ATPAREN = 55,                   /* ATPAREN  */
  YYSYMBOL_SIMULT = 56,                    /* SIMULT  */
  YYSYMBOL_PATTERN = 57,                   /* PATTERN  */
  YYSYMBOL_CODE = 58,                      /* CODE  */
  YYSYMBOL_TRANSPORT = 59,                 /* TRANSPORT  */
  YYSYMBOL_HOST = 60,                      /* HOST  */
  YYSYMBOL_TIME = 61,                      /* TIME  */
  YYSYMBOL_WHENEVER = 62,                  /* WHENEVER  */
  YYSYMBOL_NEXT = 63,                      /* NEXT  */
  YYSYMBOL_UNTIL = 64,                     /* UNTIL  */
  YYSYMBOL_EXTERNAL = 65,                  /* EXTERNAL  */
  YYSYMBOL_GLOBAL = 66,                    /* GLOBAL  */
  YYSYMBOL_EVERY = 67,                     /* EVERY  */
  YYSYMBOL_BEFORE = 68,                    /* BEFORE  */
  YYSYMBOL_AFTER = 69,                     /* AFTER  */
  YYSYMBOL_AT = 70,                        /* AT  */
  YYSYMBOL_AT_SYM = 71,                    /* AT_SYM  */
  YYSYMBOL_ATAT_SYM = 72,                  /* ATAT_SYM  */
  YYSYMBOL_NEW = 73,                       /* NEW  */
  YYSYMBOL_SIZEOF = 74,                    /* SIZEOF  */
  YYSYMBOL_TYPEOF = 75,                    /* TYPEOF  */
  YYSYMBOL_SAME = 76,                      /* SAME  */
  YYSYMBOL_PLUS_CHUCK = 77,                /* PLUS_CHUCK  */
  YYSYMBOL_MINUS_CHUCK = 78,               /* MINUS_CHUCK  */
  YYSYMBOL_TIMES_CHUCK = 79,               /* TIMES_CHUCK  */
  YYSYMBOL_DIVIDE_CHUCK = 80,              /* DIVIDE_CHUCK  */
  YYSYMBOL_S_AND_CHUCK = 81,               /* S_AND_CHUCK  */
  YYSYMBOL_S_OR_CHUCK = 82,                /* S_OR_CHUCK  */
  YYSYMBOL_S_XOR_CHUCK = 83,               /* S_XOR_CHUCK  */
  YYSYMBOL_SHIFT_RIGHT_CHUCK = 84,         /* SHIFT_RIGHT_CHUCK  */
  YYSYMBOL_SHIFT_LEFT_CHUCK = 85,          /* SHIFT_LEFT_CHUCK  */
  YYSYMBOL_PERCENT_CHUCK = 86,             /* PERCENT_CHUCK  */
  YYSYMBOL_SHIFT_RIGHT = 87,               /* SHIFT_RIGHT  */
  YYSYMBOL_SHIFT_LEFT = 88,                /* SHIFT_LEFT  */
  YYSYMBOL_TILDA = 89,                     /* TILDA  */
  YYSYMBOL_CHUCK = 90,                     /* CHUCK  */
  YYSYMBOL_COLONCOLON = 91,                /* COLONCOLON  */
  YYSYMBOL_S_CHUCK = 92,                   /* S_CHUCK  */
  YYSYMBOL_AT_CHUCK = 93,                  /* AT_CHUCK  */
  YYSYMBOL_LEFT_S_CHUCK = 94,              /* LEFT_S_CHUCK  */
  YYSYMBOL_UNCHUCK = 95,                   /* UNCHUCK  */
  YYSYMBOL_UPCHUCK = 96,                   /* UPCHUCK  */
  YYSYMBOL_CLASS = 97,                     /* CLASS  */
  YYSYMBOL_INTERFACE = 98,                 /* INTERFACE  */
  YYSYMBOL_EXTENDS = 99,                   /* EXTENDS  */
  YYSYMBOL_IMPLEMENTS = 100,               /* IMPLEMENTS  */
  YYSYMBOL_PUBLIC = 101,                   /* PUBLIC  */
  YYSYMBOL_PROTECTED = 102,                /* PROTECTED  */
  YYSYMBOL_PRIVATE = 103,                  /* PRIVATE  */
  YYSYMBOL_STATIC = 104,                   /* STATIC  */
  YYSYMBOL_ABSTRACT = 105,                 /* ABSTRACT  */
  YYSYMBOL_CONST = 106,                    /* CONST  */
  YYSYMBOL_SPORK = 107,                    /* SPORK  */
  YYSYMBOL_ARROW_RIGHT = 108,              /* ARROW_RIGHT  */
  YYSYMBOL_ARROW_LEFT = 109,               /* ARROW_LEFT  */
  YYSYMBOL_L_HACK = 110,                   /* L_HACK  */
  YYSYMBOL_R_HACK = 111,                   /* R_HACK  */
  YYSYMBOL_YYACCEPT = 112,                 /* $accept  */
  YYSYMBOL_program = 113,                  /* program  */
  YYSYMBOL_program_section = 114,          /* program_section  */
  YYSYMBOL_class_definition = 115,         /* class_definition  */
  YYSYMBOL_class_ext = 116,                /* class_ext  */
  YYSYMBOL_class_body = 117,               /* class_body  */
  YYSYMBOL_class_body2 = 118,              /* class_body2  */
  YYSYMBOL_class_section = 119,            /* class_section  */
  YYSYMBOL_iface_ext = 120,                /* iface_ext  */
  YYSYMBOL_id_list = 121,                  /* id_list  */
  YYSYMBOL_id_dot = 122,                   /* id_dot  */
  YYSYMBOL_function_definition = 123,      /* function_definition  */
  YYSYMBOL_class_decl = 124,               /* class_decl  */
  YYSYMBOL_function_decl = 125,            /* function_decl  */
  YYSYMBOL_static_decl = 126,              /* static_decl  */
  YYSYMBOL_type_decl_a = 127,              /* type_decl_a  */
  YYSYMBOL_type_decl_b = 128,              /* type_decl_b  */
  YYSYMBOL_type_decl = 129,                /* type_decl  */
  YYSYMBOL_type_decl2 = 130,               /* type_decl2  */
  YYSYMBOL_arg_list = 131,                 /* arg_list  */
  YYSYMBOL_statement_list = 132,           /* statement_list  */
  YYSYMBOL_statement = 133,                /* statement  */
  YYSYMBOL_jump_statement = 134,           /* jump_statement  */
  YYSYMBOL_selection_statement = 135,      /* selection_statement  */
  YYSYMBOL_loop_statement = 136,           /* loop_statement  */
  YYSYMBOL_code_segment = 137,             /* code_segment  */
  YYSYMBOL_expression_statement = 138,     /* expression_statement  */
  YYSYMBOL_expression = 139,               /* expression  */
  YYSYMBOL_chuck_expression = 140,         /* chuck_expression  */
  YYSYMBOL_arrow_expression = 141,         /* arrow_expression  */
  YYSYMBOL_array_exp = 142,                /* array_exp  */
  YYSYMBOL_array_empty = 143,              /* array_empty  */
  YYSYMBOL_decl_expression = 144,          /* decl_expression  */
  YYSYMBOL_var_decl_list = 145,            /* var_decl_list  */
  YYSYMBOL_var_decl = 146,                 /* var_decl  */
  YYSYMBOL_complex_exp = 147,              /* complex_exp  */
  YYSYMBOL_polar_exp = 148,                /* polar_exp  */
  YYSYMBOL_vec_exp = 149,                  /* vec_exp  */
  YYSYMBOL_chuck_operator = 150,           /* chuck_operator  */
  YYSYMBOL_arrow_operator = 151,           /* arrow_operator  */
  YYSYMBOL_conditional_expression = 152,   /* conditional_expression  */
  YYSYMBOL_logical_or_expression = 153,    /* logical_or_expression  */
  YYSYMBOL_logical_and_expression = 154,   /* logical_and_expression  */
  YYSYMBOL_inclusive_or_expression = 155,  /* inclusive_or_expression  */
  YYSYMBOL_exclusive_or_expression = 156,  /* exclusive_or_expression  */
  YYSYMBOL_and_expression = 157,           /* and_expression  */
  YYSYMBOL_equality_expression = 158,      /* equality_expression  */
  YYSYMBOL_relational_expression = 159,    /* relational_expression  */
  YYSYMBOL_shift_expression = 160,         /* shift_expression  */
  YYSYMBOL_additive_expression = 161,      /* additive_expression  */
  YYSYMBOL_multiplicative_expression = 162, /* multiplicative_expression  */
  YYSYMBOL_tilda_expression = 163,         /* tilda_expression  */
  YYSYMBOL_cast_expression = 164,          /* cast_expression  */
  YYSYMBOL_unary_expression = 165,         /* unary_expression  */
  YYSYMBOL_unary_operator = 166,           /* unary_operator  */
  YYSYMBOL_dur_expression = 167,           /* dur_expression  */
  YYSYMBOL_postfix_expression = 168,       /* postfix_expression  */
  YYSYMBOL_primary_expression = 169        /* primary_expression  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  122
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1312

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  112
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  58
/* YYNRULES -- Number of rules.  */
#define YYNRULES  184
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  319

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   366


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   190,   190,   191,   195,   196,   197,   201,   203,   205,
     207,   212,   213,   214,   215,   219,   220,   224,   225,   230,
     231,   232,   236,   240,   241,   245,   246,   250,   252,   254,
     256,   261,   262,   263,   267,   268,   269,   270,   274,   275,
     276,   280,   281,   285,   286,   295,   296,   301,   302,   306,
     307,   311,   312,   316,   317,   318,   319,   321,   325,   326,
     327,   328,   332,   334,   339,   341,   343,   345,   347,   349,
     351,   356,   357,   361,   362,   366,   367,   371,   372,   377,
     378,   383,   384,   389,   390,   394,   395,   396,   397,   398,
     399,   400,   404,   405,   409,   410,   411,   415,   420,   425,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   447,   448,   452,   453,   458,   459,
     464,   465,   470,   471,   476,   477,   482,   483,   488,   489,
     491,   496,   497,   499,   501,   503,   508,   509,   511,   516,
     517,   519,   524,   525,   527,   529,   534,   535,   540,   541,
     546,   547,   549,   551,   553,   555,   557,   559,   566,   567,
     568,   569,   570,   571,   576,   577,   582,   583,   585,   587,
     589,   591,   593,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ID", "STRING_LIT",
  "CHAR_LIT", "NUM", "FLOAT", "POUND", "COMMA", "COLON", "SEMICOLON",
  "LPAREN", "RPAREN", "LBRACK", "RBRACK", "LBRACE", "RBRACE", "DOT",
  "PLUS", "MINUS", "TIMES", "DIVIDE", "PERCENT", "EQ", "NEQ", "LT", "LE",
  "GT", "GE", "AND", "OR", "ASSIGN", "IF", "THEN", "ELSE", "WHILE", "FOR",
  "DO", "LOOP", "BREAK", "CONTINUE", "NULL_TOK", "FUNCTION", "RETURN",
  "QUESTION", "EXCLAMATION", "S_OR", "S_AND", "S_XOR", "PLUSPLUS",
  "MINUSMINUS", "DOLLAR", "POUNDPAREN", "PERCENTPAREN", "ATPAREN",
  "SIMULT", "PATTERN", "CODE", "TRANSPORT", "HOST", "TIME", "WHENEVER",
  "NEXT", "UNTIL", "EXTERNAL", "GLOBAL", "EVERY", "BEFORE", "AFTER", "AT",
  "AT_SYM", "ATAT_SYM", "NEW", "SIZEOF", "TYPEOF", "SAME", "PLUS_CHUCK",
  "MINUS_CHUCK", "TIMES_CHUCK", "DIVIDE_CHUCK", "S_AND_CHUCK",
  "S_OR_CHUCK", "S_XOR_CHUCK", "SHIFT_RIGHT_CHUCK", "SHIFT_LEFT_CHUCK",
  "PERCENT_CHUCK", "SHIFT_RIGHT", "SHIFT_LEFT", "TILDA", "CHUCK",
  "COLONCOLON", "S_CHUCK", "AT_CHUCK", "LEFT_S_CHUCK", "UNCHUCK",
  "UPCHUCK", "CLASS", "INTERFACE", "EXTENDS", "IMPLEMENTS", "PUBLIC",
  "PROTECTED", "PRIVATE", "STATIC", "ABSTRACT", "CONST", "SPORK",
  "ARROW_RIGHT", "ARROW_LEFT", "L_HACK", "R_HACK", "$accept", "program",
  "program_section", "class_definition", "class_ext", "class_body",
  "class_body2", "class_section", "iface_ext", "id_list", "id_dot",
  "function_definition", "class_decl", "function_decl", "static_decl",
  "type_decl_a", "type_decl_b", "type_decl", "type_decl2", "arg_list",
  "statement_list", "statement", "jump_statement", "selection_statement",
  "loop_statement", "code_segment", "expression_statement", "expression",
  "chuck_expression", "arrow_expression", "array_exp", "array_empty",
  "decl_expression", "var_decl_list", "var_decl", "complex_exp",
  "polar_exp", "vec_exp", "chuck_operator", "arrow_operator",
  "conditional_expression", "logical_or_expression",
  "logical_and_expression", "inclusive_or_expression",
  "exclusive_or_expression", "and_expression", "equality_expression",
  "relational_expression", "shift_expression", "additive_expression",
  "multiplicative_expression", "tilda_expression", "cast_expression",
  "unary_expression", "unary_operator", "dur_expression",
  "postfix_expression", "primary_expression", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-247)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-42)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     433,    10,  -247,  -247,  -247,  -247,  -247,   729,  1137,   512,
    -247,  -247,  -247,    46,    41,    68,    75,   664,    84,    88,
      99,  -247,   803,  -247,  1202,  1202,  1137,  1137,  1137,    92,
      44,    44,    44,  1202,  1202,   131,  -247,   -26,  -247,    58,
      19,    56,  1137,   147,  -247,  -247,  -247,    81,    32,  -247,
    -247,   131,   664,  -247,  -247,  -247,  -247,  -247,  -247,    98,
      35,    73,  -247,  -247,  -247,  -247,  -247,  -247,    17,   145,
     125,   128,   141,   200,   177,   142,   215,   193,   103,   144,
    -247,  1202,   108,    14,  -247,  -247,  -247,    69,    37,  -247,
     588,   176,   198,  1137,  1137,   877,     5,  1137,  -247,  -247,
    -247,   115,  -247,  -247,  -247,    79,    80,    93,  1137,   160,
     131,   131,   225,  -247,  -247,   233,  -247,   244,   131,   131,
    -247,     0,  -247,  -247,   252,   252,  -247,  -247,    44,  -247,
    -247,  1137,  -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,
    -247,  -247,  -247,  -247,  -247,  -247,  -247,  1137,  -247,  -247,
    1137,  1202,  1137,  1202,  1202,  1202,  1202,  1202,  1202,  1202,
    1202,  1202,  1202,  1202,  1202,  1202,  1202,  1202,  1202,  1202,
    1202,    44,  -247,    30,   942,   255,  -247,  -247,  -247,  -247,
     225,  -247,    46,   190,   114,   120,   877,   250,   251,   130,
    -247,  -247,  -247,  -247,   133,  -247,  -247,  -247,  1007,  -247,
     253,   131,  -247,  -247,  -247,   257,     1,    -2,   254,   261,
      35,    73,  -247,   145,   228,   125,   128,   141,   200,   177,
     177,   142,   142,   142,   142,   215,   215,   193,   193,   103,
     103,   103,   144,  -247,    14,  -247,   135,  -247,  -247,  -247,
    -247,   664,   664,  1072,  1137,  1137,   664,   664,  -247,   256,
    -247,   252,   275,    46,   252,   259,   275,   252,   267,   258,
     253,   260,  1202,  -247,   234,  -247,   664,   151,   156,   161,
    -247,  -247,  -247,  -247,  -247,   271,  -247,   354,  -247,   664,
     170,   178,   275,   273,  -247,   275,    60,  -247,   664,  -247,
     664,   282,   286,  -247,  -247,   252,    46,   281,  -247,   283,
      39,   131,   289,  -247,  -247,  -247,  -247,  -247,  -247,  -247,
    -247,  -247,  -247,   290,    40,    44,  -247,  -247,  -247
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
      33,   173,   176,   177,   174,   175,    73,     0,     0,     0,
     158,   159,   162,     0,     0,     0,     0,     0,     0,     0,
       0,    34,     0,   161,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   160,    35,    36,    37,
       0,     0,     0,    33,     2,     6,     5,     0,    40,    45,
      46,     0,     4,    51,    56,    55,    54,    57,    53,     0,
      75,    77,   178,    79,   179,   180,   181,    85,   116,   118,
     120,   122,   124,   126,   128,   131,   136,   139,   142,   146,
     148,     0,   150,   164,   166,    42,   184,     0,     0,    71,
       0,    25,     0,     0,     0,     0,     0,     0,    60,    61,
      58,     0,   173,   151,   152,     0,     0,     0,     0,    41,
       0,     0,   156,   155,   154,    94,    90,    92,     0,     0,
     163,     0,     1,     3,     0,     0,    38,    39,     0,    86,
      52,     0,    74,   102,   103,   104,   105,   111,   112,   113,
     106,   107,   108,   100,   101,   109,   110,     0,   115,   114,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   153,     0,     0,     0,   171,   172,   167,   183,
      81,    72,     0,    43,     0,     0,     0,     0,     0,     0,
      59,    97,    98,    99,     0,    87,    88,   157,     0,    95,
      96,     0,    91,    89,   182,    23,     0,     0,    47,     0,
      76,    78,    80,   119,     0,   121,   123,   125,   127,   129,
     130,   132,   134,   133,   135,   138,   137,   140,   141,   143,
     144,   145,   147,   149,   165,   168,     0,   170,    82,    26,
      44,     0,     0,     0,     0,     0,     0,     0,    83,     0,
      93,     0,    33,     0,     0,     0,    33,     0,     0,     0,
      48,     0,     0,   169,    62,    64,     0,     0,     0,     0,
      70,    68,    84,    24,    21,     0,    15,    33,    20,    19,
      13,    11,    33,     0,    22,    33,     0,   117,     0,    66,
       0,     0,     0,     7,    18,     0,     0,     0,     9,     0,
       0,     0,     0,    63,    67,    65,    69,    14,    12,     8,
      10,    30,    28,    49,     0,     0,    29,    27,    50
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -247,  -247,   241,    15,  -247,  -225,    26,  -247,  -247,  -119,
    -174,    16,  -247,  -247,  -247,  -247,  -247,   -30,  -247,   -11,
      18,   -14,  -247,  -247,  -247,  -246,   -83,    -3,   174,   159,
     -72,   101,   157,   -44,     9,  -247,  -247,  -247,  -247,  -247,
      55,  -247,   169,   171,   168,   172,   167,    86,    48,    82,
      94,    50,   162,    -4,  -247,  -247,   158,  -247
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,    43,    44,   274,   255,   275,   276,   277,   258,   206,
      92,   278,    47,    48,   128,    49,    50,    51,   209,   302,
     279,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,   200,    63,   116,   117,    64,    65,    66,   147,   150,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     110,   111,   112,    96,    87,    88,   207,   129,   239,   131,
     119,   178,   186,   -41,   256,    45,    46,   252,    52,   101,
     103,   104,   109,   105,   106,   107,   174,    90,     8,   113,
     114,   283,   175,   102,     2,     3,     4,     5,   130,   121,
     197,   187,     7,   199,     8,    13,   131,   109,   151,    91,
     311,   316,   180,    93,   312,     9,     9,   297,    45,    46,
     299,    52,   152,   109,   176,   177,   195,   196,   317,   188,
      13,   -31,   -31,   300,   202,   203,   130,   172,   131,   280,
      94,    85,   179,    26,    27,    28,    13,    95,   131,   131,
     184,   185,   191,   192,   189,   118,    97,   257,   208,    98,
     253,   254,   131,   243,   108,   194,   193,   131,   238,   132,
      99,   204,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   308,   131,   131,   143,   190,   241,   144,   131,
     145,   146,   273,   242,   115,   281,   126,   127,   284,   131,
      42,   233,   131,   246,   131,   120,   247,   122,   263,   214,
       1,     2,     3,     4,     5,   -32,   -32,   250,     6,     7,
     131,     8,   178,     9,   290,   131,    10,    11,    12,   291,
     131,   236,   154,    13,   292,   153,   307,   155,   124,   125,
      14,   148,   149,    15,    16,    17,    18,    19,    20,   156,
      21,    22,   170,    23,   182,    88,   171,    24,    25,   173,
      26,    27,    28,   159,   160,   161,   162,   221,   222,   223,
     224,    29,    30,    31,   167,   168,   169,   229,   230,   231,
      32,    33,    34,    35,   157,   158,   183,   264,   265,   163,
     164,    85,   270,   271,   165,   166,    36,   131,   262,     8,
     267,   268,   269,   219,   220,   225,   226,   198,    37,    38,
      39,    40,   289,   201,    41,   205,   301,    42,   237,   227,
     228,   240,   244,   245,   261,   130,   251,   249,   259,   288,
     295,   272,   286,   248,   303,   282,   304,   296,     1,     2,
       3,     4,     5,   285,   123,   301,     6,     7,   293,     8,
     298,     9,   -16,   305,    10,    11,    12,   306,   309,   315,
     310,    13,   314,   294,   318,   210,   211,   212,    14,   260,
     313,    15,    16,    17,    18,    19,    20,   287,    21,    22,
     213,    23,   216,   218,   215,    24,    25,   217,    26,    27,
      28,   234,   232,     0,     0,     0,     0,     0,     0,    29,
      30,    31,     0,     0,     0,     0,     0,     0,    32,    33,
      34,    35,     0,     0,     0,     0,     0,     1,     2,     3,
       4,     5,     0,     0,    36,     6,     7,     0,     8,     0,
       9,   -17,     0,    10,    11,    12,    37,    38,    39,    40,
      13,     0,    41,     0,     0,    42,     0,    14,     0,     0,
      15,    16,    17,    18,    19,    20,     0,    21,    22,     0,
      23,     0,     0,     0,    24,    25,     0,    26,    27,    28,
       0,     0,     0,     0,     0,     0,     0,     0,    29,    30,
      31,     0,     0,     0,     0,     0,     0,    32,    33,    34,
      35,     0,     0,     0,     0,     0,     1,     2,     3,     4,
       5,     0,     0,    36,     6,     7,     0,     8,     0,     9,
       0,     0,    10,    11,    12,    37,    38,    39,    40,    13,
       0,    41,     0,     0,    42,     0,    14,     0,     0,    15,
      16,    17,    18,    19,    20,     0,    21,    22,     0,    23,
       0,     0,     0,    24,    25,     0,    26,    27,    28,     0,
       0,     0,     0,     0,     0,     0,     0,    29,    30,    31,
       0,     0,     0,     0,     0,     0,    32,    33,    34,    35,
       0,     0,     0,     0,     0,     1,     2,     3,     4,     5,
       0,     0,    36,     6,     7,     0,     8,     0,     9,    89,
       0,    10,    11,    12,    37,    38,    39,    40,    13,     0,
      41,     0,     0,    42,     0,    14,     0,     0,    15,    16,
      17,    18,    19,    20,     0,     0,    22,     0,    23,     0,
       0,     0,    24,    25,     0,    26,    27,    28,     0,     0,
       0,     0,     0,     0,     0,     0,    29,    30,    31,     0,
       0,     0,     0,     0,     0,    32,    33,    34,    35,     0,
       0,     1,     2,     3,     4,     5,     0,     0,     0,     6,
       7,    36,     8,     0,     9,   181,     0,    10,    11,    12,
       0,     0,     0,     0,    13,     0,    40,     0,     0,    41,
       0,    14,    42,     0,    15,    16,    17,    18,    19,    20,
       0,     0,    22,     0,    23,     0,     0,     0,    24,    25,
       0,    26,    27,    28,     0,     0,     0,     0,     0,     0,
       0,     0,    29,    30,    31,     0,     0,     0,     0,     0,
       0,    32,    33,    34,    35,     0,     0,     1,     2,     3,
       4,     5,     0,     0,     0,     6,     7,    36,     8,     0,
       9,     0,     0,    10,    11,    12,     0,     0,     0,     0,
      13,     0,    40,     0,     0,    41,     0,    14,    42,     0,
      15,    16,    17,    18,    19,    20,     0,     0,    22,     0,
      23,     0,     0,     0,    24,    25,     0,    26,    27,    28,
       0,     0,     0,     0,     0,     0,     0,     0,    29,    30,
      31,     0,     1,     2,     3,     4,     5,    32,    33,    34,
      35,     7,    86,     8,     0,     0,     0,     0,    10,    11,
      12,     0,     0,    36,     0,    13,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    40,     0,
       0,    41,     0,     0,    42,    23,     0,     0,     0,    24,
      25,     0,    26,    27,    28,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    30,    31,     0,     0,     0,     0,
       0,     0,    32,    33,    34,    35,     1,     2,     3,     4,
       5,     0,     0,     0,   100,     7,     0,     8,    36,     0,
       0,     0,    10,    11,    12,     0,     0,     0,     0,    13,
       0,     0,     0,    40,     0,     0,    41,     0,     0,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    23,
       0,     0,     0,    24,    25,     0,    26,    27,    28,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    30,    31,
       0,     0,     0,     0,     0,     0,    32,    33,    34,    35,
       1,     2,     3,     4,     5,     0,     0,     0,     6,     7,
       0,     8,    36,     0,     0,     0,    10,    11,    12,     0,
       0,     0,     0,    13,     0,     0,     0,    40,     0,     0,
      41,     0,     0,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    23,     0,     0,     0,    24,    25,     0,
      26,    27,    28,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    30,    31,     0,     1,     2,     3,     4,     5,
      32,    33,    34,    35,     7,   235,     8,     0,     0,     0,
       0,    10,    11,    12,     0,     0,    36,     0,    13,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    40,     0,     0,    41,     0,     0,    42,    23,     0,
       0,     0,    24,    25,     0,    26,    27,    28,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    30,    31,     0,
       1,     2,     3,     4,     5,    32,    33,    34,    35,     7,
       0,     8,   248,     0,     0,     0,    10,    11,    12,     0,
       0,    36,     0,    13,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    40,     0,     0,    41,
       0,     0,    42,    23,     0,     0,     0,    24,    25,     0,
      26,    27,    28,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    30,    31,     0,     1,     2,     3,     4,     5,
      32,    33,    34,    35,     7,   266,     8,     0,     0,     0,
       0,    10,    11,    12,     0,     0,    36,     0,    13,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    40,     0,     0,    41,     0,     0,    42,    23,     0,
       0,     0,    24,    25,     0,    26,    27,    28,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    30,    31,     0,
       1,     2,     3,     4,     5,    32,    33,    34,    35,     7,
       0,     8,     0,     0,     0,     0,    10,    11,    12,     0,
       0,    36,     0,    13,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    40,     0,     0,    41,
       0,     0,    42,    23,     0,     0,     0,    24,    25,     0,
      26,    27,    28,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    30,    31,     0,   102,     2,     3,     4,     5,
      32,    33,    34,    35,     7,     0,     8,     0,     0,     0,
       0,    10,    11,    12,     0,     0,    36,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    40,     0,     0,    41,     0,     0,    42,    23,     0,
       0,     0,    24,    25,     0,    26,    27,    28,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    32,    33,    34,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    36,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    41,
       0,     0,    42
};

static const yytype_int16 yycheck[] =
{
      30,    31,    32,    17,     7,     8,   125,    51,   182,     9,
      40,    83,    95,     3,    16,     0,     0,    16,     0,    22,
      24,    25,     3,    26,    27,    28,    12,     9,    14,    33,
      34,   256,    18,     3,     4,     5,     6,     7,    52,    42,
     112,    36,    12,   115,    14,    26,     9,     3,    31,     3,
      11,    11,    15,    12,   300,    16,    16,   282,    43,    43,
     285,    43,    45,     3,    50,    51,   110,   111,   314,    64,
      26,    97,    98,    13,   118,   119,    90,    81,     9,   253,
      12,    71,    13,    53,    54,    55,    26,    12,     9,     9,
      93,    94,    13,    13,    97,    76,    12,    99,   128,    11,
      99,   100,     9,   186,    12,   108,    13,     9,   180,    11,
      11,   111,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,   296,     9,     9,    90,    11,    13,    93,     9,
      95,    96,   251,    13,     3,   254,   104,   105,   257,     9,
     110,   171,     9,    13,     9,    89,    13,     0,    13,   152,
       3,     4,     5,     6,     7,    97,    98,   201,    11,    12,
       9,    14,   234,    16,    13,     9,    19,    20,    21,    13,
       9,   174,    47,    26,    13,    30,   295,    49,    97,    98,
      33,   108,   109,    36,    37,    38,    39,    40,    41,    48,
      43,    44,    89,    46,    18,   198,    52,    50,    51,    91,
      53,    54,    55,    26,    27,    28,    29,   159,   160,   161,
     162,    64,    65,    66,    21,    22,    23,   167,   168,   169,
      73,    74,    75,    76,    24,    25,    28,   241,   242,    87,
      88,    71,   246,   247,    19,    20,    89,     9,    10,    14,
     243,   244,   245,   157,   158,   163,   164,    14,   101,   102,
     103,   104,   266,     9,   107,     3,   286,   110,     3,   165,
     166,    71,    12,    12,     3,   279,     9,    14,    14,    35,
     100,    15,    12,    15,   288,    16,   290,    99,     3,     4,
       5,     6,     7,    16,    43,   315,    11,    12,    17,    14,
      17,    16,    17,    11,    19,    20,    21,    11,    17,     9,
      17,    26,    13,   277,   315,   131,   147,   150,    33,   208,
     301,    36,    37,    38,    39,    40,    41,   262,    43,    44,
     151,    46,   154,   156,   153,    50,    51,   155,    53,    54,
      55,   173,   170,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      65,    66,    -1,    -1,    -1,    -1,    -1,    -1,    73,    74,
      75,    76,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    89,    11,    12,    -1,    14,    -1,
      16,    17,    -1,    19,    20,    21,   101,   102,   103,   104,
      26,    -1,   107,    -1,    -1,   110,    -1,    33,    -1,    -1,
      36,    37,    38,    39,    40,    41,    -1,    43,    44,    -1,
      46,    -1,    -1,    -1,    50,    51,    -1,    53,    54,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    65,
      66,    -1,    -1,    -1,    -1,    -1,    -1,    73,    74,    75,
      76,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    89,    11,    12,    -1,    14,    -1,    16,
      -1,    -1,    19,    20,    21,   101,   102,   103,   104,    26,
      -1,   107,    -1,    -1,   110,    -1,    33,    -1,    -1,    36,
      37,    38,    39,    40,    41,    -1,    43,    44,    -1,    46,
      -1,    -1,    -1,    50,    51,    -1,    53,    54,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    65,    66,
      -1,    -1,    -1,    -1,    -1,    -1,    73,    74,    75,    76,
      -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    89,    11,    12,    -1,    14,    -1,    16,    17,
      -1,    19,    20,    21,   101,   102,   103,   104,    26,    -1,
     107,    -1,    -1,   110,    -1,    33,    -1,    -1,    36,    37,
      38,    39,    40,    41,    -1,    -1,    44,    -1,    46,    -1,
      -1,    -1,    50,    51,    -1,    53,    54,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    64,    65,    66,    -1,
      -1,    -1,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    11,
      12,    89,    14,    -1,    16,    17,    -1,    19,    20,    21,
      -1,    -1,    -1,    -1,    26,    -1,   104,    -1,    -1,   107,
      -1,    33,   110,    -1,    36,    37,    38,    39,    40,    41,
      -1,    -1,    44,    -1,    46,    -1,    -1,    -1,    50,    51,
      -1,    53,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    65,    66,    -1,    -1,    -1,    -1,    -1,
      -1,    73,    74,    75,    76,    -1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    11,    12,    89,    14,    -1,
      16,    -1,    -1,    19,    20,    21,    -1,    -1,    -1,    -1,
      26,    -1,   104,    -1,    -1,   107,    -1,    33,   110,    -1,
      36,    37,    38,    39,    40,    41,    -1,    -1,    44,    -1,
      46,    -1,    -1,    -1,    50,    51,    -1,    53,    54,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    65,
      66,    -1,     3,     4,     5,     6,     7,    73,    74,    75,
      76,    12,    13,    14,    -1,    -1,    -1,    -1,    19,    20,
      21,    -1,    -1,    89,    -1,    26,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   104,    -1,
      -1,   107,    -1,    -1,   110,    46,    -1,    -1,    -1,    50,
      51,    -1,    53,    54,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    66,    -1,    -1,    -1,    -1,
      -1,    -1,    73,    74,    75,    76,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    11,    12,    -1,    14,    89,    -1,
      -1,    -1,    19,    20,    21,    -1,    -1,    -1,    -1,    26,
      -1,    -1,    -1,   104,    -1,    -1,   107,    -1,    -1,   110,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,
      -1,    -1,    -1,    50,    51,    -1,    53,    54,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    66,
      -1,    -1,    -1,    -1,    -1,    -1,    73,    74,    75,    76,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    11,    12,
      -1,    14,    89,    -1,    -1,    -1,    19,    20,    21,    -1,
      -1,    -1,    -1,    26,    -1,    -1,    -1,   104,    -1,    -1,
     107,    -1,    -1,   110,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    46,    -1,    -1,    -1,    50,    51,    -1,
      53,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    66,    -1,     3,     4,     5,     6,     7,
      73,    74,    75,    76,    12,    13,    14,    -1,    -1,    -1,
      -1,    19,    20,    21,    -1,    -1,    89,    -1,    26,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   104,    -1,    -1,   107,    -1,    -1,   110,    46,    -1,
      -1,    -1,    50,    51,    -1,    53,    54,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    66,    -1,
       3,     4,     5,     6,     7,    73,    74,    75,    76,    12,
      -1,    14,    15,    -1,    -1,    -1,    19,    20,    21,    -1,
      -1,    89,    -1,    26,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,   107,
      -1,    -1,   110,    46,    -1,    -1,    -1,    50,    51,    -1,
      53,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    66,    -1,     3,     4,     5,     6,     7,
      73,    74,    75,    76,    12,    13,    14,    -1,    -1,    -1,
      -1,    19,    20,    21,    -1,    -1,    89,    -1,    26,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   104,    -1,    -1,   107,    -1,    -1,   110,    46,    -1,
      -1,    -1,    50,    51,    -1,    53,    54,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    66,    -1,
       3,     4,     5,     6,     7,    73,    74,    75,    76,    12,
      -1,    14,    -1,    -1,    -1,    -1,    19,    20,    21,    -1,
      -1,    89,    -1,    26,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,   107,
      -1,    -1,   110,    46,    -1,    -1,    -1,    50,    51,    -1,
      53,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    66,    -1,     3,     4,     5,     6,     7,
      73,    74,    75,    76,    12,    -1,    14,    -1,    -1,    -1,
      -1,    19,    20,    21,    -1,    -1,    89,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   104,    -1,    -1,   107,    -1,    -1,   110,    46,    -1,
      -1,    -1,    50,    51,    -1,    53,    54,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    73,    74,    75,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   107,
      -1,    -1,   110
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,     5,     6,     7,    11,    12,    14,    16,
      19,    20,    21,    26,    33,    36,    37,    38,    39,    40,
      41,    43,    44,    46,    50,    51,    53,    54,    55,    64,
      65,    66,    73,    74,    75,    76,    89,   101,   102,   103,
     104,   107,   110,   113,   114,   115,   123,   124,   125,   127,
     128,   129,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   144,   147,   148,   149,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,    71,    13,   139,   139,    17,
     132,     3,   122,    12,    12,    12,   133,    12,    11,    11,
      11,   139,     3,   165,   165,   139,   139,   139,    12,     3,
     129,   129,   129,   165,   165,     3,   145,   146,    76,   129,
      89,   139,     0,   114,    97,    98,   104,   105,   126,   145,
     133,     9,    11,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    90,    93,    95,    96,   150,   108,   109,
     151,    31,    45,    30,    47,    49,    48,    24,    25,    26,
      27,    28,    29,    87,    88,    19,    20,    21,    22,    23,
      89,    52,   165,    91,    12,    18,    50,    51,   142,    13,
      15,    17,    18,    28,   139,   139,   138,    36,    64,   139,
      11,    13,    13,    13,   139,   145,   145,   142,    14,   142,
     143,     9,   145,   145,   111,     3,   121,   121,   129,   130,
     140,   141,   144,   154,   139,   155,   156,   157,   158,   159,
     159,   160,   160,   160,   160,   161,   161,   162,   162,   163,
     163,   163,   164,   129,   168,    13,   139,     3,   142,   122,
      71,    13,    13,   138,    12,    12,    13,    13,    15,    14,
     145,     9,    16,    99,   100,   116,    16,    99,   120,    14,
     143,     3,    10,    13,   133,   133,    13,   139,   139,   139,
     133,   133,    15,   121,   115,   117,   118,   119,   123,   132,
     122,   121,    16,   117,   121,    16,    12,   152,    35,   133,
      13,    13,    13,    17,   118,   100,    99,   117,    17,   117,
      13,   129,   131,   133,   133,    11,    11,   121,   122,    17,
      17,    11,   137,   146,    13,     9,    11,   137,   131
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_uint8 yyr1[] =
{
       0,   112,   113,   113,   114,   114,   114,   115,   115,   115,
     115,   116,   116,   116,   116,   117,   117,   118,   118,   119,
     119,   119,   120,   121,   121,   122,   122,   123,   123,   123,
     123,   124,   124,   124,   125,   125,   125,   125,   126,   126,
     126,   127,   127,   128,   128,   129,   129,   130,   130,   131,
     131,   132,   132,   133,   133,   133,   133,   133,   134,   134,
     134,   134,   135,   135,   136,   136,   136,   136,   136,   136,
     136,   137,   137,   138,   138,   139,   139,   140,   140,   141,
     141,   142,   142,   143,   143,   144,   144,   144,   144,   144,
     144,   144,   145,   145,   146,   146,   146,   147,   148,   149,
     150,   150,   150,   150,   150,   150,   150,   150,   150,   150,
     150,   150,   150,   150,   151,   151,   152,   152,   153,   153,
     154,   154,   155,   155,   156,   156,   157,   157,   158,   158,
     158,   159,   159,   159,   159,   159,   160,   160,   160,   161,
     161,   161,   162,   162,   162,   162,   163,   163,   164,   164,
     165,   165,   165,   165,   165,   165,   165,   165,   166,   166,
     166,   166,   166,   166,   167,   167,   168,   168,   168,   168,
     168,   168,   168,   169,   169,   169,   169,   169,   169,   169,
     169,   169,   169,   169,   169
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     1,     6,     7,     6,
       7,     2,     4,     2,     4,     1,     0,     1,     2,     1,
       1,     1,     2,     1,     3,     1,     3,     8,     7,     8,
       7,     1,     1,     0,     1,     1,     1,     1,     1,     1,
       0,     1,     2,     3,     4,     1,     1,     1,     2,     2,
       4,     1,     2,     1,     1,     1,     1,     1,     2,     3,
       2,     2,     5,     7,     5,     7,     6,     7,     5,     7,
       5,     2,     3,     1,     2,     1,     3,     1,     3,     1,
       3,     3,     4,     2,     3,     1,     2,     3,     3,     3,
       2,     3,     1,     3,     1,     2,     2,     3,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     5,     1,     3,
       1,     3,     1,     3,     1,     3,     1,     3,     1,     3,
       3,     1,     3,     3,     3,     3,     1,     3,     3,     1,
       3,     3,     1,     3,     3,     3,     1,     3,     1,     3,
       1,     2,     2,     2,     2,     2,     2,     3,     1,     1,
       1,     1,     1,     2,     1,     3,     1,     2,     3,     4,
       3,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     3,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* program: program_section  */
#line 190 "chuck.y"
                                            { (yyval.program) = g_program = new_program( (yyvsp[0].program_section), EM_lineNum ); }
#line 1737 "chuck.tab.c"
    break;

  case 3: /* program: program program_section  */
#line 191 "chuck.y"
                                            { (yyval.program) = g_program = append_program( (yyvsp[-1].program), (yyvsp[0].program_section), EM_lineNum ); }
#line 1743 "chuck.tab.c"
    break;

  case 4: /* program_section: statement_list  */
#line 195 "chuck.y"
                                            { (yyval.program_section) = new_section_stmt( (yyvsp[0].stmt_list), EM_lineNum ); }
#line 1749 "chuck.tab.c"
    break;

  case 5: /* program_section: function_definition  */
#line 196 "chuck.y"
                                            { (yyval.program_section) = new_section_func_def( (yyvsp[0].func_def), EM_lineNum ); }
#line 1755 "chuck.tab.c"
    break;

  case 6: /* program_section: class_definition  */
#line 197 "chuck.y"
                                            { (yyval.program_section) = new_section_class_def( (yyvsp[0].class_def), EM_lineNum ); }
#line 1761 "chuck.tab.c"
    break;

  case 7: /* class_definition: class_decl CLASS id_list LBRACE class_body RBRACE  */
#line 202 "chuck.y"
            { (yyval.class_def) = new_class_def( (yyvsp[-5].ival), (yyvsp[-3].id_list), NULL, (yyvsp[-1].class_body), EM_lineNum ); }
#line 1767 "chuck.tab.c"
    break;

  case 8: /* class_definition: class_decl CLASS id_list class_ext LBRACE class_body RBRACE  */
#line 204 "chuck.y"
            { (yyval.class_def) = new_class_def( (yyvsp[-6].ival), (yyvsp[-4].id_list), (yyvsp[-3].class_ext), (yyvsp[-1].class_body), EM_lineNum ); }
#line 1773 "chuck.tab.c"
    break;

  case 9: /* class_definition: class_decl INTERFACE id_list LBRACE class_body RBRACE  */
#line 206 "chuck.y"
            { (yyval.class_def) = new_iface_def( (yyvsp[-5].ival), (yyvsp[-3].id_list), NULL, (yyvsp[-1].class_body), EM_lineNum ); }
#line 1779 "chuck.tab.c"
    break;

  case 10: /* class_definition: class_decl INTERFACE id_list iface_ext LBRACE class_body RBRACE  */
#line 208 "chuck.y"
            { (yyval.class_def) = new_iface_def( (yyvsp[-6].ival), (yyvsp[-4].id_list), (yyvsp[-3].class_ext), (yyvsp[-1].class_body), EM_lineNum ); }
#line 1785 "chuck.tab.c"
    break;

  case 11: /* class_ext: IMPLEMENTS id_list  */
#line 212 "chuck.y"
                                            { (yyval.class_ext) = new_class_ext( NULL, (yyvsp[0].id_list), EM_lineNum ); }
#line 1791 "chuck.tab.c"
    break;

  case 12: /* class_ext: IMPLEMENTS id_list EXTENDS id_dot  */
#line 213 "chuck.y"
                                            { (yyval.class_ext) = new_class_ext( (yyvsp[0].id_list), (yyvsp[-2].id_list), EM_lineNum ); }
#line 1797 "chuck.tab.c"
    break;

  case 13: /* class_ext: EXTENDS id_dot  */
#line 214 "chuck.y"
                                            { (yyval.class_ext) = new_class_ext( (yyvsp[0].id_list), NULL, EM_lineNum ); }
#line 1803 "chuck.tab.c"
    break;

  case 14: /* class_ext: EXTENDS id_dot IMPLEMENTS id_list  */
#line 215 "chuck.y"
                                            { (yyval.class_ext) = new_class_ext( (yyvsp[-2].id_list), (yyvsp[0].id_list), EM_lineNum ); }
#line 1809 "chuck.tab.c"
    break;

  case 15: /* class_body: class_body2  */
#line 219 "chuck.y"
                                            { (yyval.class_body) = (yyvsp[0].class_body); }
#line 1815 "chuck.tab.c"
    break;

  case 16: /* class_body: %empty  */
#line 220 "chuck.y"
                                                    { (yyval.class_body) = NULL; }
#line 1821 "chuck.tab.c"
    break;

  case 17: /* class_body2: class_section  */
#line 224 "chuck.y"
                                            { (yyval.class_body) = new_class_body( (yyvsp[0].program_section), EM_lineNum ); }
#line 1827 "chuck.tab.c"
    break;

  case 18: /* class_body2: class_section class_body2  */
#line 225 "chuck.y"
                                            { (yyval.class_body) = prepend_class_body( (yyvsp[-1].program_section), (yyvsp[0].class_body), EM_lineNum ); }
#line 1833 "chuck.tab.c"
    break;

  case 19: /* class_section: statement_list  */
#line 230 "chuck.y"
                                            { (yyval.program_section) = new_section_stmt( (yyvsp[0].stmt_list), EM_lineNum ); }
#line 1839 "chuck.tab.c"
    break;

  case 20: /* class_section: function_definition  */
#line 231 "chuck.y"
                                            { (yyval.program_section) = new_section_func_def( (yyvsp[0].func_def), EM_lineNum ); }
#line 1845 "chuck.tab.c"
    break;

  case 21: /* class_section: class_definition  */
#line 232 "chuck.y"
                                            { (yyval.program_section) = new_section_class_def( (yyvsp[0].class_def), EM_lineNum ); }
#line 1851 "chuck.tab.c"
    break;

  case 22: /* iface_ext: EXTENDS id_list  */
#line 236 "chuck.y"
                                            { (yyval.class_ext) = new_class_ext( NULL, (yyvsp[0].id_list), EM_lineNum ); }
#line 1857 "chuck.tab.c"
    break;

  case 23: /* id_list: ID  */
#line 240 "chuck.y"
                                            { (yyval.id_list) = new_id_list( (yyvsp[0].sval), EM_lineNum ); }
#line 1863 "chuck.tab.c"
    break;

  case 24: /* id_list: ID COMMA id_list  */
#line 241 "chuck.y"
                                            { (yyval.id_list) = prepend_id_list( (yyvsp[-2].sval), (yyvsp[0].id_list), EM_lineNum ); }
#line 1869 "chuck.tab.c"
    break;

  case 25: /* id_dot: ID  */
#line 245 "chuck.y"
                                            { (yyval.id_list) = new_id_list( (yyvsp[0].sval), EM_lineNum ); }
#line 1875 "chuck.tab.c"
    break;

  case 26: /* id_dot: ID DOT id_dot  */
#line 246 "chuck.y"
                                            { (yyval.id_list) = prepend_id_list( (yyvsp[-2].sval), (yyvsp[0].id_list), EM_lineNum ); }
#line 1881 "chuck.tab.c"
    break;

  case 27: /* function_definition: function_decl static_decl type_decl2 ID LPAREN arg_list RPAREN code_segment  */
#line 251 "chuck.y"
            { (yyval.func_def) = new_func_def( (yyvsp[-7].ival), (yyvsp[-6].ival), (yyvsp[-5].type_decl), (yyvsp[-4].sval), (yyvsp[-2].arg_list), (yyvsp[0].stmt), EM_lineNum ); }
#line 1887 "chuck.tab.c"
    break;

  case 28: /* function_definition: function_decl static_decl type_decl2 ID LPAREN RPAREN code_segment  */
#line 253 "chuck.y"
            { (yyval.func_def) = new_func_def( (yyvsp[-6].ival), (yyvsp[-5].ival), (yyvsp[-4].type_decl), (yyvsp[-3].sval), NULL, (yyvsp[0].stmt), EM_lineNum ); }
#line 1893 "chuck.tab.c"
    break;

  case 29: /* function_definition: function_decl static_decl type_decl2 ID LPAREN arg_list RPAREN SEMICOLON  */
#line 255 "chuck.y"
            { (yyval.func_def) = new_func_def( (yyvsp[-7].ival), (yyvsp[-6].ival), (yyvsp[-5].type_decl), (yyvsp[-4].sval), (yyvsp[-2].arg_list), NULL, EM_lineNum ); }
#line 1899 "chuck.tab.c"
    break;

  case 30: /* function_definition: function_decl static_decl type_decl2 ID LPAREN RPAREN SEMICOLON  */
#line 257 "chuck.y"
            { (yyval.func_def) = new_func_def( (yyvsp[-6].ival), (yyvsp[-5].ival), (yyvsp[-4].type_decl), (yyvsp[-3].sval), NULL, NULL, EM_lineNum ); }
#line 1905 "chuck.tab.c"
    break;

  case 31: /* class_decl: PUBLIC  */
#line 261 "chuck.y"
                                            { (yyval.ival) = ae_key_public; }
#line 1911 "chuck.tab.c"
    break;

  case 32: /* class_decl: PRIVATE  */
#line 262 "chuck.y"
                                            { (yyval.ival) = ae_key_private; }
#line 1917 "chuck.tab.c"
    break;

  case 33: /* class_decl: %empty  */
#line 263 "chuck.y"
                                            { (yyval.ival) = ae_key_private; }
#line 1923 "chuck.tab.c"
    break;

  case 34: /* function_decl: FUNCTION  */
#line 267 "chuck.y"
                                            { (yyval.ival) = ae_key_func; }
#line 1929 "chuck.tab.c"
    break;

  case 35: /* function_decl: PUBLIC  */
#line 268 "chuck.y"
                                            { (yyval.ival) = ae_key_public; }
#line 1935 "chuck.tab.c"
    break;

  case 36: /* function_decl: PROTECTED  */
#line 269 "chuck.y"
                                            { (yyval.ival) = ae_key_protected; }
#line 1941 "chuck.tab.c"
    break;

  case 37: /* function_decl: PRIVATE  */
#line 270 "chuck.y"
                                            { (yyval.ival) = ae_key_private; }
#line 1947 "chuck.tab.c"
    break;

  case 38: /* static_decl: STATIC  */
#line 274 "chuck.y"
                                            { (yyval.ival) = ae_key_static; }
#line 1953 "chuck.tab.c"
    break;

  case 39: /* static_decl: ABSTRACT  */
#line 275 "chuck.y"
                                            { (yyval.ival) = ae_key_abstract; }
#line 1959 "chuck.tab.c"
    break;

  case 40: /* static_decl: %empty  */
#line 276 "chuck.y"
                                            { (yyval.ival) = ae_key_instance; }
#line 1965 "chuck.tab.c"
    break;

  case 41: /* type_decl_a: ID  */
#line 280 "chuck.y"
                                            { (yyval.type_decl) = new_type_decl( new_id_list( (yyvsp[0].sval), EM_lineNum ), 0, EM_lineNum ); }
#line 1971 "chuck.tab.c"
    break;

  case 42: /* type_decl_a: ID AT_SYM  */
#line 281 "chuck.y"
                                            { (yyval.type_decl) = new_type_decl( new_id_list( (yyvsp[-1].sval), EM_lineNum ), 1, EM_lineNum ); }
#line 1977 "chuck.tab.c"
    break;

  case 43: /* type_decl_b: LT id_dot GT  */
#line 285 "chuck.y"
                                            { (yyval.type_decl) = new_type_decl( (yyvsp[-1].id_list), 0, EM_lineNum ); }
#line 1983 "chuck.tab.c"
    break;

  case 44: /* type_decl_b: LT id_dot GT AT_SYM  */
#line 286 "chuck.y"
                                            { (yyval.type_decl) = new_type_decl( (yyvsp[-2].id_list), 1, EM_lineNum ); }
#line 1989 "chuck.tab.c"
    break;

  case 45: /* type_decl: type_decl_a  */
#line 295 "chuck.y"
                                            { (yyval.type_decl) = (yyvsp[0].type_decl); }
#line 1995 "chuck.tab.c"
    break;

  case 46: /* type_decl: type_decl_b  */
#line 296 "chuck.y"
                                            { (yyval.type_decl) = (yyvsp[0].type_decl); }
#line 2001 "chuck.tab.c"
    break;

  case 47: /* type_decl2: type_decl  */
#line 301 "chuck.y"
                                            { (yyval.type_decl) = (yyvsp[0].type_decl); }
#line 2007 "chuck.tab.c"
    break;

  case 48: /* type_decl2: type_decl array_empty  */
#line 302 "chuck.y"
                                            { (yyval.type_decl) = add_type_decl_array( (yyvsp[-1].type_decl), (yyvsp[0].array_sub), EM_lineNum ); }
#line 2013 "chuck.tab.c"
    break;

  case 49: /* arg_list: type_decl var_decl  */
#line 306 "chuck.y"
                                            { (yyval.arg_list) = new_arg_list( (yyvsp[-1].type_decl), (yyvsp[0].var_decl), EM_lineNum ); }
#line 2019 "chuck.tab.c"
    break;

  case 50: /* arg_list: type_decl var_decl COMMA arg_list  */
#line 307 "chuck.y"
                                            { (yyval.arg_list) = prepend_arg_list( (yyvsp[-3].type_decl), (yyvsp[-2].var_decl), (yyvsp[0].arg_list), EM_lineNum ); }
#line 2025 "chuck.tab.c"
    break;

  case 51: /* statement_list: statement  */
#line 311 "chuck.y"
                                            { (yyval.stmt_list) = new_stmt_list( (yyvsp[0].stmt), EM_lineNum ); }
#line 2031 "chuck.tab.c"
    break;

  case 52: /* statement_list: statement_list statement  */
#line 312 "chuck.y"
                                            { (yyval.stmt_list) = append_stmt_list( (yyvsp[-1].stmt_list), (yyvsp[0].stmt), EM_lineNum ); }
#line 2037 "chuck.tab.c"
    break;

  case 53: /* statement: expression_statement  */
#line 316 "chuck.y"
                                            { (yyval.stmt) = (yyvsp[0].stmt); }
#line 2043 "chuck.tab.c"
    break;

  case 54: /* statement: loop_statement  */
#line 317 "chuck.y"
                                            { (yyval.stmt) = (yyvsp[0].stmt); }
#line 2049 "chuck.tab.c"
    break;

  case 55: /* statement: selection_statement  */
#line 318 "chuck.y"
                                            { (yyval.stmt) = (yyvsp[0].stmt); }
#line 2055 "chuck.tab.c"
    break;

  case 56: /* statement: jump_statement  */
#line 319 "chuck.y"
                                            { (yyval.stmt) = (yyvsp[0].stmt); }
#line 2061 "chuck.tab.c"
    break;

  case 57: /* statement: code_segment  */
#line 321 "chuck.y"
                                            { (yyval.stmt) = (yyvsp[0].stmt); }
#line 2067 "chuck.tab.c"
    break;

  case 58: /* jump_statement: RETURN SEMICOLON  */
#line 325 "chuck.y"
                                            { (yyval.stmt) = new_stmt_from_return( NULL, EM_lineNum ); }
#line 2073 "chuck.tab.c"
    break;

  case 59: /* jump_statement: RETURN expression SEMICOLON  */
#line 326 "chuck.y"
                                            { (yyval.stmt) = new_stmt_from_return( (yyvsp[-1].exp), EM_lineNum ); }
#line 2079 "chuck.tab.c"
    break;

  case 60: /* jump_statement: BREAK SEMICOLON  */
#line 327 "chuck.y"
                                            { (yyval.stmt) = new_stmt_from_break( EM_lineNum ); }
#line 2085 "chuck.tab.c"
    break;

  case 61: /* jump_statement: CONTINUE SEMICOLON  */
#line 328 "chuck.y"
                                            { (yyval.stmt) = new_stmt_from_continue( EM_lineNum ); }
#line 2091 "chuck.tab.c"
    break;

  case 62: /* selection_statement: IF LPAREN expression RPAREN statement  */
#line 333 "chuck.y"
            { (yyval.stmt) = new_stmt_from_if( (yyvsp[-2].exp), (yyvsp[0].stmt), NULL, EM_lineNum ); }
#line 2097 "chuck.tab.c"
    break;

  case 63: /* selection_statement: IF LPAREN expression RPAREN statement ELSE statement  */
#line 335 "chuck.y"
            { (yyval.stmt) = new_stmt_from_if( (yyvsp[-4].exp), (yyvsp[-2].stmt), (yyvsp[0].stmt), EM_lineNum ); }
#line 2103 "chuck.tab.c"
    break;

  case 64: /* loop_statement: WHILE LPAREN expression RPAREN statement  */
#line 340 "chuck.y"
            { (yyval.stmt) = new_stmt_from_while( (yyvsp[-2].exp), (yyvsp[0].stmt), EM_lineNum ); }
#line 2109 "chuck.tab.c"
    break;

  case 65: /* loop_statement: DO statement WHILE LPAREN expression RPAREN SEMICOLON  */
#line 342 "chuck.y"
            { (yyval.stmt) = new_stmt_from_do_while( (yyvsp[-2].exp), (yyvsp[-5].stmt), EM_lineNum ); }
#line 2115 "chuck.tab.c"
    break;

  case 66: /* loop_statement: FOR LPAREN expression_statement expression_statement RPAREN statement  */
#line 344 "chuck.y"
            { (yyval.stmt) = new_stmt_from_for( (yyvsp[-3].stmt), (yyvsp[-2].stmt), NULL, (yyvsp[0].stmt), EM_lineNum ); }
#line 2121 "chuck.tab.c"
    break;

  case 67: /* loop_statement: FOR LPAREN expression_statement expression_statement expression RPAREN statement  */
#line 346 "chuck.y"
            { (yyval.stmt) = new_stmt_from_for( (yyvsp[-4].stmt), (yyvsp[-3].stmt), (yyvsp[-2].exp), (yyvsp[0].stmt), EM_lineNum ); }
#line 2127 "chuck.tab.c"
    break;

  case 68: /* loop_statement: UNTIL LPAREN expression RPAREN statement  */
#line 348 "chuck.y"
            { (yyval.stmt) = new_stmt_from_until( (yyvsp[-2].exp), (yyvsp[0].stmt), EM_lineNum ); }
#line 2133 "chuck.tab.c"
    break;

  case 69: /* loop_statement: DO statement UNTIL LPAREN expression RPAREN SEMICOLON  */
#line 350 "chuck.y"
            { (yyval.stmt) = new_stmt_from_do_until( (yyvsp[-2].exp), (yyvsp[-5].stmt), EM_lineNum ); }
#line 2139 "chuck.tab.c"
    break;

  case 70: /* loop_statement: LOOP LPAREN expression RPAREN statement  */
#line 352 "chuck.y"
            { (yyval.stmt) = new_stmt_from_loop( (yyvsp[-2].exp), (yyvsp[0].stmt), EM_lineNum ); }
#line 2145 "chuck.tab.c"
    break;

  case 71: /* code_segment: LBRACE RBRACE  */
#line 356 "chuck.y"
                                            { (yyval.stmt) = new_stmt_from_code( NULL, EM_lineNum ); }
#line 2151 "chuck.tab.c"
    break;

  case 72: /* code_segment: LBRACE statement_list RBRACE  */
#line 357 "chuck.y"
                                            { (yyval.stmt) = new_stmt_from_code( (yyvsp[-1].stmt_list), EM_lineNum ); }
#line 2157 "chuck.tab.c"
    break;

  case 73: /* expression_statement: SEMICOLON  */
#line 361 "chuck.y"
                                            { (yyval.stmt) = NULL; }
#line 2163 "chuck.tab.c"
    break;

  case 74: /* expression_statement: expression SEMICOLON  */
#line 362 "chuck.y"
                                            { (yyval.stmt) = new_stmt_from_expression( (yyvsp[-1].exp), EM_lineNum ); }
#line 2169 "chuck.tab.c"
    break;

  case 75: /* expression: chuck_expression  */
#line 366 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2175 "chuck.tab.c"
    break;

  case 76: /* expression: expression COMMA chuck_expression  */
#line 367 "chuck.y"
                                             { (yyval.exp) = append_expression( (yyvsp[-2].exp), (yyvsp[0].exp), EM_lineNum ); }
#line 2181 "chuck.tab.c"
    break;

  case 77: /* chuck_expression: arrow_expression  */
#line 371 "chuck.y"
                                             { (yyval.exp) = (yyvsp[0].exp); }
#line 2187 "chuck.tab.c"
    break;

  case 78: /* chuck_expression: chuck_expression chuck_operator arrow_expression  */
#line 373 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), (yyvsp[-1].ival), (yyvsp[0].exp), EM_lineNum ); }
#line 2193 "chuck.tab.c"
    break;

  case 79: /* arrow_expression: decl_expression  */
#line 377 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2199 "chuck.tab.c"
    break;

  case 80: /* arrow_expression: arrow_expression arrow_operator decl_expression  */
#line 379 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), (yyvsp[-1].ival), (yyvsp[0].exp), EM_lineNum ); }
#line 2205 "chuck.tab.c"
    break;

  case 81: /* array_exp: LBRACK expression RBRACK  */
#line 383 "chuck.y"
                                            { (yyval.array_sub) = new_array_sub( (yyvsp[-1].exp), EM_lineNum ); }
#line 2211 "chuck.tab.c"
    break;

  case 82: /* array_exp: LBRACK expression RBRACK array_exp  */
#line 385 "chuck.y"
            { (yyval.array_sub) = prepend_array_sub( (yyvsp[0].array_sub), (yyvsp[-2].exp), EM_lineNum ); }
#line 2217 "chuck.tab.c"
    break;

  case 83: /* array_empty: LBRACK RBRACK  */
#line 389 "chuck.y"
                                            { (yyval.array_sub) = new_array_sub( NULL, EM_lineNum ); }
#line 2223 "chuck.tab.c"
    break;

  case 84: /* array_empty: array_empty LBRACK RBRACK  */
#line 390 "chuck.y"
                                            { (yyval.array_sub) = prepend_array_sub( (yyvsp[-2].array_sub), NULL, EM_lineNum ); }
#line 2229 "chuck.tab.c"
    break;

  case 85: /* decl_expression: conditional_expression  */
#line 394 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2235 "chuck.tab.c"
    break;

  case 86: /* decl_expression: type_decl var_decl_list  */
#line 395 "chuck.y"
                                            { (yyval.exp) = new_exp_decl( (yyvsp[-1].type_decl), (yyvsp[0].var_decl_list), 0, EM_lineNum ); }
#line 2241 "chuck.tab.c"
    break;

  case 87: /* decl_expression: EXTERNAL type_decl var_decl_list  */
#line 396 "chuck.y"
                                            { (yyval.exp) = new_exp_decl_external( (yyvsp[-1].type_decl), (yyvsp[0].var_decl_list), 0, EM_lineNum ); }
#line 2247 "chuck.tab.c"
    break;

  case 88: /* decl_expression: GLOBAL type_decl var_decl_list  */
#line 397 "chuck.y"
                                            { (yyval.exp) = new_exp_decl_global( (yyvsp[-1].type_decl), (yyvsp[0].var_decl_list), 0, EM_lineNum ); }
#line 2253 "chuck.tab.c"
    break;

  case 89: /* decl_expression: STATIC type_decl var_decl_list  */
#line 398 "chuck.y"
                                            { (yyval.exp) = new_exp_decl( (yyvsp[-1].type_decl), (yyvsp[0].var_decl_list), 1, EM_lineNum ); }
#line 2259 "chuck.tab.c"
    break;

  case 90: /* decl_expression: SAME var_decl_list  */
#line 399 "chuck.y"
                                            { (yyval.exp) = new_exp_decl( NULL, (yyvsp[0].var_decl_list), 0, EM_lineNum ); }
#line 2265 "chuck.tab.c"
    break;

  case 91: /* decl_expression: STATIC SAME var_decl_list  */
#line 400 "chuck.y"
                                            { (yyval.exp) = new_exp_decl( NULL, (yyvsp[0].var_decl_list), 1, EM_lineNum ); }
#line 2271 "chuck.tab.c"
    break;

  case 92: /* var_decl_list: var_decl  */
#line 404 "chuck.y"
                                            { (yyval.var_decl_list) = new_var_decl_list( (yyvsp[0].var_decl), EM_lineNum ); }
#line 2277 "chuck.tab.c"
    break;

  case 93: /* var_decl_list: var_decl COMMA var_decl_list  */
#line 405 "chuck.y"
                                            { (yyval.var_decl_list) = prepend_var_decl_list( (yyvsp[-2].var_decl), (yyvsp[0].var_decl_list), EM_lineNum ); }
#line 2283 "chuck.tab.c"
    break;

  case 94: /* var_decl: ID  */
#line 409 "chuck.y"
                                            { (yyval.var_decl) = new_var_decl( (yyvsp[0].sval), NULL, EM_lineNum ); }
#line 2289 "chuck.tab.c"
    break;

  case 95: /* var_decl: ID array_exp  */
#line 410 "chuck.y"
                                            { (yyval.var_decl) = new_var_decl( (yyvsp[-1].sval), (yyvsp[0].array_sub), EM_lineNum ); }
#line 2295 "chuck.tab.c"
    break;

  case 96: /* var_decl: ID array_empty  */
#line 411 "chuck.y"
                                            { (yyval.var_decl) = new_var_decl( (yyvsp[-1].sval), (yyvsp[0].array_sub), EM_lineNum ); }
#line 2301 "chuck.tab.c"
    break;

  case 97: /* complex_exp: POUNDPAREN expression RPAREN  */
#line 416 "chuck.y"
            { (yyval.complex_exp) = new_complex( (yyvsp[-1].exp), EM_lineNum ); }
#line 2307 "chuck.tab.c"
    break;

  case 98: /* polar_exp: PERCENTPAREN expression RPAREN  */
#line 421 "chuck.y"
            { (yyval.polar_exp) = new_polar( (yyvsp[-1].exp), EM_lineNum ); }
#line 2313 "chuck.tab.c"
    break;

  case 99: /* vec_exp: ATPAREN expression RPAREN  */
#line 426 "chuck.y"
            { (yyval.vec_exp) = new_vec( (yyvsp[-1].exp), EM_lineNum ); }
#line 2319 "chuck.tab.c"
    break;

  case 100: /* chuck_operator: CHUCK  */
#line 430 "chuck.y"
                                            { (yyval.ival) = ae_op_chuck; }
#line 2325 "chuck.tab.c"
    break;

  case 101: /* chuck_operator: AT_CHUCK  */
#line 431 "chuck.y"
                                            { (yyval.ival) = ae_op_at_chuck; }
#line 2331 "chuck.tab.c"
    break;

  case 102: /* chuck_operator: PLUS_CHUCK  */
#line 432 "chuck.y"
                                            { (yyval.ival) = ae_op_plus_chuck; }
#line 2337 "chuck.tab.c"
    break;

  case 103: /* chuck_operator: MINUS_CHUCK  */
#line 433 "chuck.y"
                                            { (yyval.ival) = ae_op_minus_chuck; }
#line 2343 "chuck.tab.c"
    break;

  case 104: /* chuck_operator: TIMES_CHUCK  */
#line 434 "chuck.y"
                                            { (yyval.ival) = ae_op_times_chuck; }
#line 2349 "chuck.tab.c"
    break;

  case 105: /* chuck_operator: DIVIDE_CHUCK  */
#line 435 "chuck.y"
                                            { (yyval.ival) = ae_op_divide_chuck; }
#line 2355 "chuck.tab.c"
    break;

  case 106: /* chuck_operator: SHIFT_RIGHT_CHUCK  */
#line 436 "chuck.y"
                                            { (yyval.ival) = ae_op_shift_right_chuck; }
#line 2361 "chuck.tab.c"
    break;

  case 107: /* chuck_operator: SHIFT_LEFT_CHUCK  */
#line 437 "chuck.y"
                                            { (yyval.ival) = ae_op_shift_left_chuck; }
#line 2367 "chuck.tab.c"
    break;

  case 108: /* chuck_operator: PERCENT_CHUCK  */
#line 438 "chuck.y"
                                            { (yyval.ival) = ae_op_percent_chuck; }
#line 2373 "chuck.tab.c"
    break;

  case 109: /* chuck_operator: UNCHUCK  */
#line 439 "chuck.y"
                                            { (yyval.ival) = ae_op_unchuck; }
#line 2379 "chuck.tab.c"
    break;

  case 110: /* chuck_operator: UPCHUCK  */
#line 440 "chuck.y"
                                            { (yyval.ival) = ae_op_upchuck; }
#line 2385 "chuck.tab.c"
    break;

  case 111: /* chuck_operator: S_AND_CHUCK  */
#line 441 "chuck.y"
                                            { (yyval.ival) = ae_op_s_and_chuck; }
#line 2391 "chuck.tab.c"
    break;

  case 112: /* chuck_operator: S_OR_CHUCK  */
#line 442 "chuck.y"
                                            { (yyval.ival) = ae_op_s_or_chuck; }
#line 2397 "chuck.tab.c"
    break;

  case 113: /* chuck_operator: S_XOR_CHUCK  */
#line 443 "chuck.y"
                                            { (yyval.ival) = ae_op_s_xor_chuck; }
#line 2403 "chuck.tab.c"
    break;

  case 114: /* arrow_operator: ARROW_LEFT  */
#line 447 "chuck.y"
                                            { (yyval.ival) = ae_op_arrow_left; }
#line 2409 "chuck.tab.c"
    break;

  case 115: /* arrow_operator: ARROW_RIGHT  */
#line 448 "chuck.y"
                                            { (yyval.ival) = ae_op_arrow_right; }
#line 2415 "chuck.tab.c"
    break;

  case 116: /* conditional_expression: logical_or_expression  */
#line 452 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2421 "chuck.tab.c"
    break;

  case 117: /* conditional_expression: logical_or_expression QUESTION expression COLON conditional_expression  */
#line 454 "chuck.y"
            { (yyval.exp) = new_exp_from_if( (yyvsp[-4].exp), (yyvsp[-2].exp), (yyvsp[0].exp), EM_lineNum ); }
#line 2427 "chuck.tab.c"
    break;

  case 118: /* logical_or_expression: logical_and_expression  */
#line 458 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2433 "chuck.tab.c"
    break;

  case 119: /* logical_or_expression: logical_or_expression OR logical_and_expression  */
#line 460 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_or, (yyvsp[0].exp), EM_lineNum ); }
#line 2439 "chuck.tab.c"
    break;

  case 120: /* logical_and_expression: inclusive_or_expression  */
#line 464 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2445 "chuck.tab.c"
    break;

  case 121: /* logical_and_expression: logical_and_expression AND inclusive_or_expression  */
#line 466 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_and, (yyvsp[0].exp), EM_lineNum ); }
#line 2451 "chuck.tab.c"
    break;

  case 122: /* inclusive_or_expression: exclusive_or_expression  */
#line 470 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2457 "chuck.tab.c"
    break;

  case 123: /* inclusive_or_expression: inclusive_or_expression S_OR exclusive_or_expression  */
#line 472 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_s_or, (yyvsp[0].exp), EM_lineNum ); }
#line 2463 "chuck.tab.c"
    break;

  case 124: /* exclusive_or_expression: and_expression  */
#line 476 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2469 "chuck.tab.c"
    break;

  case 125: /* exclusive_or_expression: exclusive_or_expression S_XOR and_expression  */
#line 478 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_s_xor, (yyvsp[0].exp), EM_lineNum ); }
#line 2475 "chuck.tab.c"
    break;

  case 126: /* and_expression: equality_expression  */
#line 482 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2481 "chuck.tab.c"
    break;

  case 127: /* and_expression: and_expression S_AND equality_expression  */
#line 484 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_s_and, (yyvsp[0].exp), EM_lineNum ); }
#line 2487 "chuck.tab.c"
    break;

  case 128: /* equality_expression: relational_expression  */
#line 488 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2493 "chuck.tab.c"
    break;

  case 129: /* equality_expression: equality_expression EQ relational_expression  */
#line 490 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_eq, (yyvsp[0].exp), EM_lineNum ); }
#line 2499 "chuck.tab.c"
    break;

  case 130: /* equality_expression: equality_expression NEQ relational_expression  */
#line 492 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_neq, (yyvsp[0].exp), EM_lineNum ); }
#line 2505 "chuck.tab.c"
    break;

  case 131: /* relational_expression: shift_expression  */
#line 496 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2511 "chuck.tab.c"
    break;

  case 132: /* relational_expression: relational_expression LT shift_expression  */
#line 498 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_lt, (yyvsp[0].exp), EM_lineNum ); }
#line 2517 "chuck.tab.c"
    break;

  case 133: /* relational_expression: relational_expression GT shift_expression  */
#line 500 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_gt, (yyvsp[0].exp), EM_lineNum ); }
#line 2523 "chuck.tab.c"
    break;

  case 134: /* relational_expression: relational_expression LE shift_expression  */
#line 502 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_le, (yyvsp[0].exp), EM_lineNum ); }
#line 2529 "chuck.tab.c"
    break;

  case 135: /* relational_expression: relational_expression GE shift_expression  */
#line 504 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_ge, (yyvsp[0].exp), EM_lineNum ); }
#line 2535 "chuck.tab.c"
    break;

  case 136: /* shift_expression: additive_expression  */
#line 508 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2541 "chuck.tab.c"
    break;

  case 137: /* shift_expression: shift_expression SHIFT_LEFT additive_expression  */
#line 510 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_shift_left, (yyvsp[0].exp), EM_lineNum ); }
#line 2547 "chuck.tab.c"
    break;

  case 138: /* shift_expression: shift_expression SHIFT_RIGHT additive_expression  */
#line 512 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_shift_right, (yyvsp[0].exp), EM_lineNum ); }
#line 2553 "chuck.tab.c"
    break;

  case 139: /* additive_expression: multiplicative_expression  */
#line 516 "chuck.y"
                                             { (yyval.exp) = (yyvsp[0].exp); }
#line 2559 "chuck.tab.c"
    break;

  case 140: /* additive_expression: additive_expression PLUS multiplicative_expression  */
#line 518 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_plus, (yyvsp[0].exp), EM_lineNum ); }
#line 2565 "chuck.tab.c"
    break;

  case 141: /* additive_expression: additive_expression MINUS multiplicative_expression  */
#line 520 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_minus, (yyvsp[0].exp), EM_lineNum ); }
#line 2571 "chuck.tab.c"
    break;

  case 142: /* multiplicative_expression: tilda_expression  */
#line 524 "chuck.y"
                                             { (yyval.exp) = (yyvsp[0].exp); }
#line 2577 "chuck.tab.c"
    break;

  case 143: /* multiplicative_expression: multiplicative_expression TIMES tilda_expression  */
#line 526 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_times, (yyvsp[0].exp), EM_lineNum ); }
#line 2583 "chuck.tab.c"
    break;

  case 144: /* multiplicative_expression: multiplicative_expression DIVIDE tilda_expression  */
#line 528 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_divide, (yyvsp[0].exp), EM_lineNum ); }
#line 2589 "chuck.tab.c"
    break;

  case 145: /* multiplicative_expression: multiplicative_expression PERCENT tilda_expression  */
#line 530 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_percent, (yyvsp[0].exp), EM_lineNum ); }
#line 2595 "chuck.tab.c"
    break;

  case 146: /* tilda_expression: cast_expression  */
#line 534 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2601 "chuck.tab.c"
    break;

  case 147: /* tilda_expression: tilda_expression TILDA cast_expression  */
#line 536 "chuck.y"
            { (yyval.exp) = new_exp_from_binary( (yyvsp[-2].exp), ae_op_tilda, (yyvsp[0].exp), EM_lineNum ); }
#line 2607 "chuck.tab.c"
    break;

  case 148: /* cast_expression: unary_expression  */
#line 540 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2613 "chuck.tab.c"
    break;

  case 149: /* cast_expression: cast_expression DOLLAR type_decl  */
#line 542 "chuck.y"
            { (yyval.exp) = new_exp_from_cast( (yyvsp[0].type_decl), (yyvsp[-2].exp), EM_lineNum ); }
#line 2619 "chuck.tab.c"
    break;

  case 150: /* unary_expression: dur_expression  */
#line 546 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2625 "chuck.tab.c"
    break;

  case 151: /* unary_expression: PLUSPLUS unary_expression  */
#line 548 "chuck.y"
            { (yyval.exp) = new_exp_from_unary( ae_op_plusplus, (yyvsp[0].exp), EM_lineNum ); }
#line 2631 "chuck.tab.c"
    break;

  case 152: /* unary_expression: MINUSMINUS unary_expression  */
#line 550 "chuck.y"
            { (yyval.exp) = new_exp_from_unary( ae_op_minusminus, (yyvsp[0].exp), EM_lineNum ); }
#line 2637 "chuck.tab.c"
    break;

  case 153: /* unary_expression: unary_operator unary_expression  */
#line 552 "chuck.y"
            { (yyval.exp) = new_exp_from_unary( (yyvsp[-1].ival), (yyvsp[0].exp), EM_lineNum ); }
#line 2643 "chuck.tab.c"
    break;

  case 154: /* unary_expression: TYPEOF unary_expression  */
#line 554 "chuck.y"
            { (yyval.exp) = new_exp_from_unary( ae_op_typeof, (yyvsp[0].exp), EM_lineNum ); }
#line 2649 "chuck.tab.c"
    break;

  case 155: /* unary_expression: SIZEOF unary_expression  */
#line 556 "chuck.y"
            { (yyval.exp) = new_exp_from_unary( ae_op_sizeof, (yyvsp[0].exp), EM_lineNum ); }
#line 2655 "chuck.tab.c"
    break;

  case 156: /* unary_expression: NEW type_decl  */
#line 558 "chuck.y"
            { (yyval.exp) = new_exp_from_unary2( ae_op_new, (yyvsp[0].type_decl), NULL, EM_lineNum ); }
#line 2661 "chuck.tab.c"
    break;

  case 157: /* unary_expression: NEW type_decl array_exp  */
#line 560 "chuck.y"
            { (yyval.exp) = new_exp_from_unary2( ae_op_new, (yyvsp[-1].type_decl), (yyvsp[0].array_sub), EM_lineNum ); }
#line 2667 "chuck.tab.c"
    break;

  case 158: /* unary_operator: PLUS  */
#line 566 "chuck.y"
                                            { (yyval.ival) = ae_op_plus; }
#line 2673 "chuck.tab.c"
    break;

  case 159: /* unary_operator: MINUS  */
#line 567 "chuck.y"
                                            { (yyval.ival) = ae_op_minus; }
#line 2679 "chuck.tab.c"
    break;

  case 160: /* unary_operator: TILDA  */
#line 568 "chuck.y"
                                            { (yyval.ival) = ae_op_tilda; }
#line 2685 "chuck.tab.c"
    break;

  case 161: /* unary_operator: EXCLAMATION  */
#line 569 "chuck.y"
                                            { (yyval.ival) = ae_op_exclamation; }
#line 2691 "chuck.tab.c"
    break;

  case 162: /* unary_operator: TIMES  */
#line 570 "chuck.y"
                                            { (yyval.ival) = ae_op_times; }
#line 2697 "chuck.tab.c"
    break;

  case 163: /* unary_operator: SPORK TILDA  */
#line 571 "chuck.y"
                                            { (yyval.ival) = ae_op_spork; }
#line 2703 "chuck.tab.c"
    break;

  case 165: /* dur_expression: dur_expression COLONCOLON postfix_expression  */
#line 578 "chuck.y"
            { (yyval.exp) = new_exp_from_dur( (yyvsp[-2].exp), (yyvsp[0].exp), EM_lineNum ); }
#line 2709 "chuck.tab.c"
    break;

  case 166: /* postfix_expression: primary_expression  */
#line 582 "chuck.y"
                                            { (yyval.exp) = (yyvsp[0].exp); }
#line 2715 "chuck.tab.c"
    break;

  case 167: /* postfix_expression: postfix_expression array_exp  */
#line 584 "chuck.y"
            { (yyval.exp) = new_exp_from_array( (yyvsp[-1].exp), (yyvsp[0].array_sub), EM_lineNum ); }
#line 2721 "chuck.tab.c"
    break;

  case 168: /* postfix_expression: postfix_expression LPAREN RPAREN  */
#line 586 "chuck.y"
            { (yyval.exp) = new_exp_from_func_call( (yyvsp[-2].exp), NULL, EM_lineNum ); }
#line 2727 "chuck.tab.c"
    break;

  case 169: /* postfix_expression: postfix_expression LPAREN expression RPAREN  */
#line 588 "chuck.y"
            { (yyval.exp) = new_exp_from_func_call( (yyvsp[-3].exp), (yyvsp[-1].exp), EM_lineNum ); }
#line 2733 "chuck.tab.c"
    break;

  case 170: /* postfix_expression: postfix_expression DOT ID  */
#line 590 "chuck.y"
            { (yyval.exp) = new_exp_from_member_dot( (yyvsp[-2].exp), (yyvsp[0].sval), EM_lineNum ); }
#line 2739 "chuck.tab.c"
    break;

  case 171: /* postfix_expression: postfix_expression PLUSPLUS  */
#line 592 "chuck.y"
            { (yyval.exp) = new_exp_from_postfix( (yyvsp[-1].exp), ae_op_plusplus, EM_lineNum ); }
#line 2745 "chuck.tab.c"
    break;

  case 172: /* postfix_expression: postfix_expression MINUSMINUS  */
#line 594 "chuck.y"
            { (yyval.exp) = new_exp_from_postfix( (yyvsp[-1].exp), ae_op_minusminus, EM_lineNum ); }
#line 2751 "chuck.tab.c"
    break;

  case 173: /* primary_expression: ID  */
#line 599 "chuck.y"
                                            { (yyval.exp) = new_exp_from_id( (yyvsp[0].sval), EM_lineNum ); }
#line 2757 "chuck.tab.c"
    break;

  case 174: /* primary_expression: NUM  */
#line 600 "chuck.y"
                                            { (yyval.exp) = new_exp_from_int( (yyvsp[0].ival), EM_lineNum ); }
#line 2763 "chuck.tab.c"
    break;

  case 175: /* primary_expression: FLOAT  */
#line 601 "chuck.y"
                                            { (yyval.exp) = new_exp_from_float( (yyvsp[0].fval), EM_lineNum ); }
#line 2769 "chuck.tab.c"
    break;

  case 176: /* primary_expression: STRING_LIT  */
#line 602 "chuck.y"
                                            { (yyval.exp) = new_exp_from_str( (yyvsp[0].sval), EM_lineNum ); }
#line 2775 "chuck.tab.c"
    break;

  case 177: /* primary_expression: CHAR_LIT  */
#line 603 "chuck.y"
                                            { (yyval.exp) = new_exp_from_char( (yyvsp[0].sval), EM_lineNum ); }
#line 2781 "chuck.tab.c"
    break;

  case 178: /* primary_expression: array_exp  */
#line 604 "chuck.y"
                                            { (yyval.exp) = new_exp_from_array_lit( (yyvsp[0].array_sub), EM_lineNum ); }
#line 2787 "chuck.tab.c"
    break;

  case 179: /* primary_expression: complex_exp  */
#line 605 "chuck.y"
                                            { (yyval.exp) = new_exp_from_complex( (yyvsp[0].complex_exp), EM_lineNum ); }
#line 2793 "chuck.tab.c"
    break;

  case 180: /* primary_expression: polar_exp  */
#line 606 "chuck.y"
                                            { (yyval.exp) = new_exp_from_polar( (yyvsp[0].polar_exp), EM_lineNum ); }
#line 2799 "chuck.tab.c"
    break;

  case 181: /* primary_expression: vec_exp  */
#line 607 "chuck.y"
                                            { (yyval.exp) = new_exp_from_vec( (yyvsp[0].vec_exp), EM_lineNum ); }
#line 2805 "chuck.tab.c"
    break;

  case 182: /* primary_expression: L_HACK expression R_HACK  */
#line 608 "chuck.y"
                                            { (yyval.exp) = new_exp_from_hack( (yyvsp[-1].exp), EM_lineNum ); }
#line 2811 "chuck.tab.c"
    break;

  case 183: /* primary_expression: LPAREN expression RPAREN  */
#line 609 "chuck.y"
                                            { (yyval.exp) = (yyvsp[-1].exp); }
#line 2817 "chuck.tab.c"
    break;

  case 184: /* primary_expression: LPAREN RPAREN  */
#line 610 "chuck.y"
                                                    { (yyval.exp) = new_exp_from_nil( EM_lineNum ); }
#line 2823 "chuck.tab.c"
    break;


#line 2827 "chuck.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

